import numpy as np

import matplotlib
#matplotlib.use('QT5Agg')
import matplotlib.pyplot as plt
import dill as pkl



def frontier_measure(min_cf, cf, mp, annuity):
    T,S = cf.shape
    max_T = len(cf)
    
    total_weighted_shortage = []
    for s in range(S):
        temp = 0
        for t in range(T):
            temp += mp[t]*(max_T-t-1)*max(cf[t,s]-annuity - min_cf,0)
#            temp += (cf[t,s] - min_cf)
#            temp += (1 if cf[t,s] - min_cf>0.0001 else 0)
        total_weighted_shortage.append(temp)
    
    return np.mean(total_weighted_shortage)
    
    


parames_raw = np.loadtxt(open('parameters/parameters_t.txt'), skiprows=1, delimiter='\t')
data = pkl.load(open('res.pkl','rb'))



mp = parames_raw[:,0] 

cfs = sorted([z['target_cf'] for z in data])

M = []
for x in data:
    m = frontier_measure(-x['target_cf'], x['cf_array'], mp, x['model_z'].value*0.05)
    M.append([x['target_cf'], m/x['target_cf']])


plt.clf()
plt.figure(figsize=(8,4))

plt.xlabel('Required Cash Flow (in thousands of dollars)')
plt.ylabel('Years')
plt.plot([z[0]*10e2 for z in M],[z[1] for z in M],'o-',
         color='black', lw=1,
         markersize=5, 
         fillstyle='full', 
         markerfacecolor='lightgray')

plt.savefig('output/frontier_normal.eps')
plt.savefig('output/frontier_normal.png')






data = pkl.load(open('res_stress.pkl','rb'))

mp = parames_raw[:,0] 

cfs = sorted([z['target_cf'] for z in data])

M = []
for x in data:
#    print(x['model_z'].value*0.03, x['target_cf'])
    m = frontier_measure(-x['target_cf'], x['cf_array'], mp, x['model_z'].value*0.05)
    M.append([x['target_cf'], m/x['target_cf']])

plt.clf()
plt.xlabel('Required Cash Flow (in thousands of dollars)')
plt.ylabel('Years')
plt.plot([z[0]*10e2 for z in M],[z[1] for z in M],'o-',
         color='black', lw=1,
         markersize=5, 
         fillstyle='full', 
         markerfacecolor='lightgray')

plt.savefig('output/frontier_stress.eps')
plt.savefig('output/frontier_stress.png')



plt.clf()
plt.xlabel('Required Cash Flow (in thousands of dollars)')
plt.ylabel('Investment in Annuity')
annuity_investments = np.array([[z['target_cf'],z['model_z'].value] for z in data])
plt.plot([z[0]*10e2 for z in annuity_investments],[z[1] for z in annuity_investments],'o-',
         color='black', lw=1,
         markersize=5, 
         fillstyle='full', 
         markerfacecolor='lightgray')

plt.savefig('output/annuity_investments_stress.eps')
plt.savefig('output/annuity_investments_stress.png')
